window.Gleam.initSearch([{"doc":"gemo","title":"gemo","content":"# gemo\n\n[![Package Version](https://img.shields.io/hexpm/v/gemo)](https://hex.pm/packages/gemo)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/gemo/)\n\n```sh\ngleam add gemo\n```\n```gleam\nimport gemo\nimport bool\n\nfn fib(n) {\n  use &lt;- gemo.memoize1(fib, n)\n  use &lt;- bool.guard(n &lt;= 1, n)\n  fib(n - 1) + fib(n - 2)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/gemo&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"gemo","title":"cache_count","content":"pub fn cache_count() -&gt; Int\n Get the amount of cached data.\nSynonyms:\ngemo.cache_count\ngemo cache_count","url":"gemo.html#cache_count"},{"doc":"gemo","title":"cache_density","content":"pub fn cache_density() -&gt; Float\n cache_size / cache_count\nSynonyms:\ngemo.cache_density\ngemo cache_density","url":"gemo.html#cache_density"},{"doc":"gemo","title":"cache_size","content":"pub fn cache_size() -&gt; Int\n Get the cache size in bytes.\nSynonyms:\ngemo.cache_size\ngemo cache_size","url":"gemo.html#cache_size"},{"doc":"gemo","title":"memoize0","content":"pub fn memoize0(func: fn() -&gt; a, cb: fn() -&gt; a) -&gt; a\n Takes the parent function as a key and executes the callback if its output is not already cached.\n This should be called with a use expression at the top of the function\n\n ## Example:\n \n fn complex_task() {\n   use &lt;- glemo.memoize0(complex_task)\n   &quot;./huge_file.csv&quot;\n   |&gt; read_file\n   |&gt; hash\n }\nSynonyms:\ngemo.memoize0\ngemo memoize0","url":"gemo.html#memoize0"},{"doc":"gemo","title":"memoize1","content":"pub fn memoize1(func: fn(a) -&gt; b, arg1: a, cb: fn() -&gt; b) -&gt; b\n Takes the parent function and its args as a key and executes the callback if its output is not already cached.\n This should be called with a use expression at the top of the function\n\n ## Example:\n \n fn fib(n) {\n   use &lt;- glemo.memoize1(fib, n)\n   use &lt;- bool.guard(n &lt;= 1, n)\n   fib(n - 1) + fib(n - 2)\n }\nSynonyms:\ngemo.memoize1\ngemo memoize1","url":"gemo.html#memoize1"},{"doc":"gemo","title":"memoize10","content":"pub fn memoize10(\n  func: fn(a, b, c, d, e, f, g, h, i, j) -&gt; k,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  arg5: e,\n  arg6: f,\n  arg7: g,\n  arg8: h,\n  arg9: i,\n  arg10: j,\n  cb: fn() -&gt; k,\n) -&gt; k\n Same as memoize1 but with 10 args.\nSynonyms:\ngemo.memoize10\ngemo memoize10","url":"gemo.html#memoize10"},{"doc":"gemo","title":"memoize2","content":"pub fn memoize2(\n  func: fn(a, b) -&gt; c,\n  arg1: a,\n  arg2: b,\n  cb: fn() -&gt; c,\n) -&gt; c\n Same as memoize1 but with 2 args.\nSynonyms:\ngemo.memoize2\ngemo memoize2","url":"gemo.html#memoize2"},{"doc":"gemo","title":"memoize3","content":"pub fn memoize3(\n  func: fn(a, b, c) -&gt; d,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  cb: fn() -&gt; d,\n) -&gt; d\n Same as memoize1 but with 3 args.\nSynonyms:\ngemo.memoize3\ngemo memoize3","url":"gemo.html#memoize3"},{"doc":"gemo","title":"memoize4","content":"pub fn memoize4(\n  func: fn(a, b, c, d) -&gt; e,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  cb: fn() -&gt; e,\n) -&gt; e\n Same as memoize1 but with 4 args.\nSynonyms:\ngemo.memoize4\ngemo memoize4","url":"gemo.html#memoize4"},{"doc":"gemo","title":"memoize5","content":"pub fn memoize5(\n  func: fn(a, b, c, d, e) -&gt; f,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  arg5: e,\n  cb: fn() -&gt; f,\n) -&gt; f\n Same as memoize1 but with 5 args.\nSynonyms:\ngemo.memoize5\ngemo memoize5","url":"gemo.html#memoize5"},{"doc":"gemo","title":"memoize6","content":"pub fn memoize6(\n  func: fn(a, b, c, d, e, f) -&gt; g,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  arg5: e,\n  arg6: f,\n  cb: fn() -&gt; g,\n) -&gt; g\n Same as memoize1 but with 6 args.\nSynonyms:\ngemo.memoize6\ngemo memoize6","url":"gemo.html#memoize6"},{"doc":"gemo","title":"memoize7","content":"pub fn memoize7(\n  func: fn(a, b, c, d, e, f, g) -&gt; h,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  arg5: e,\n  arg6: f,\n  arg7: g,\n  cb: fn() -&gt; h,\n) -&gt; h\n Same as memoize1 but with 7 args.\nSynonyms:\ngemo.memoize7\ngemo memoize7","url":"gemo.html#memoize7"},{"doc":"gemo","title":"memoize8","content":"pub fn memoize8(\n  func: fn(a, b, c, d, e, f, g, h) -&gt; i,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  arg5: e,\n  arg6: f,\n  arg7: g,\n  arg8: h,\n  cb: fn() -&gt; i,\n) -&gt; i\n Same as memoize1 but with 8 args.\nSynonyms:\ngemo.memoize8\ngemo memoize8","url":"gemo.html#memoize8"},{"doc":"gemo","title":"memoize9","content":"pub fn memoize9(\n  func: fn(a, b, c, d, e, f, g, h, i) -&gt; j,\n  arg1: a,\n  arg2: b,\n  arg3: c,\n  arg4: d,\n  arg5: e,\n  arg6: f,\n  arg7: g,\n  arg8: h,\n  arg9: i,\n  cb: fn() -&gt; j,\n) -&gt; j\n Same as memoize1 but with 9 args.\nSynonyms:\ngemo.memoize9\ngemo memoize9","url":"gemo.html#memoize9"},{"doc":"gemo","title":"reset_cache","content":"pub fn reset_cache() -&gt; Nil\n\nSynonyms:\ngemo.reset_cache\ngemo reset_cache","url":"gemo.html#reset_cache"},{"doc":"gemo","title":"gemo","content":"","url":"gemo.html"}]);